unit main;

{***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************}
 
{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Menus,
  about, Buttons, {Math,} ExtCtrls, ComCtrls, pomocne, Configure, {LinAlg,}
  {MathTypes,} Grids;

type

  { TfrmMain }

  TfrmMain = class(TForm)
    btRunInversion: TBitBtn;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    miSave: TMenuItem;
    miRun: TMenuItem;
    miInversion: TMenuItem;
    miConfigure: TMenuItem;
    miOptions: TMenuItem;
    miAbout: TMenuItem;
    miHelp: TMenuItem;
    miExit: TMenuItem;
    miOpen: TMenuItem;
    miFile: TMenuItem;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    pcKnown: TPageControl;
    SaveDialog1: TSaveDialog;
    sgKnownDepths: TStringGrid;
    SgKnownVel: TStringGrid;
    StatusBar1: TStatusBar;
    tsKnownDepths: TTabSheet;
    tsKnownVel: TTabSheet;
    procedure btRunInversionClick(Sender: TObject);
    procedure frmInvCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure frmMainCreate(Sender: TObject);
    procedure miAboutClick(Sender: TObject);
    procedure miConfigureClick(Sender: TObject);
    procedure miExitClick(Sender: TObject);
    procedure miOpenClick(Sender: TObject);
    procedure miSaveClick(Sender: TObject);
    procedure sgKnownVelDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
  private
    { private declarations }
  public
    { public declarations }
  end; 

const
{  meritko gridu, v kterem se pocitaji hloubky a rychlosti. Default
   je 1 -- nic se netransformuje, kazdy metr zacina novy radek a sloupec.
   Meritko 2 -- novy radek a sloupec zacina kazde dva metry, meritko 0.5 --
   novy radek a sloupec zacina kazdeho pul metru.}
//  Scale = 2;
{Maximalni rozdil ktery muze nastat pri interpolovani rychlosti ve vrstve mezi
puvodni a interpolovanou hodnotou}
  MaxDiff = 0.000000001;
//  NumZero = 0.0000000001; {Cisla mensi nez NumZero se budou povazovat za nulu}
  IterDiff = 0.05;
//  MaxIt = 5;
//  VelPrior = 2.5; {Inicilani hodnota rychlost, dosadi se, pokud vypoctena
//    hodnota rychlosti je nesmyslna -- napr. zaporna}
//  VelStd = 100; {Hodnota standardni odchylky ktera se dosadi pokud se pouzije
//    VelPrior}


var
  frmMain: TfrmMain;

{  meritko gridu, v kterem se pocitaji hloubky a rychlosti. Default
   je 1 -- nic se netransformuje, kazdy metr zacina novy radek a sloupec.
   Meritko 2 -- novy radek a sloupec zacina kazde dva metry, meritko 0.5 --
   novy radek a sloupec zacina kazdeho pul metru.}
  Scale: double;
  
  FieldTimeData: TTimeData; {cislo geofonu -- cislo
    odpalu [0], cas prvniho nasazeni [1], cislo vrstvy [2], identifikator
    geofonu [3]}
  TimeDataOrig: TDoubleArray; {zde se budou uchovavat puvodni netransformovane
    casy}
  ShotCoord: TCoord; {souradnice bodu odpalu -- cislo
    odpalu, x [0] a y [1] souradnice}
  GeophCoord: TCoord; {souradnice geofonu -- cislo
    geofonu, x [0] a y [1] souradnice geofonu}
  PocetOdpalu: integer; {Pocet odpalu v souboru}
  PocetZaznamu: integer; {pocet zaznamu v souboru}
  PocetGf: integer; {pocet geofonu v souboru}
  Rychlosti: T3dDoubleArray; {cislo vrstvy, x, y souradnice,
   v poli je ulozena rychlost v dane bunce}
  RychlostiStd: T3dDoubleArray; {cislo vrstvy, x, y souradnice,
   v poli je ulozena standardni odchylka rychlosti v dane bunce}
  Mocnosti: T3dDoubleArray; {cislo vrstvy, x, y souradnice,
    v poli je ulozena mocnost dane vrstvy}
  MocnostiStd: T3dDoubleArray; {cislo vrstvy, x, y souradnice,
    v poli je ulozena standandardni odchylka mocnosti dane vrstvy}
  PocetVrstev: integer; {Pocet vrstev prostredi}
  MinX, MinY, MaxX, MaxY: double;   {minimalni a maximalni souradnice geofonu
    a odpalu}
  ShotCoordTransp: TCoord; {souradnice odpalu
    transponovane do noveho souradneho systemu pomoci Scale}
  GeophCoordTransp: TCoord; {souradnice geofonu
    transponovane do noveho souradneho systemu pomoci Scale}
  ProfilCoordTransp: TDoubleArray; {Pouze pro profilova mereni. Souradnice
    geofonu a odpalu na profilu. Pokud ma geofon i odpal stejne souradnice je
    uveden jen jednou. Pouze x-souradnice, y-souradnice jsou u profiloveho
    mereni vsechny stejne}
  MinXT, MinYT, MaxXT, MaxYT: double; {Transponovane minX .... pomoci Scale}
  NrX, NrY: integer; {Pocet X a Y useku v pocitanych polich}
  VpZname: T2dIntegerArray; {pokud je rychlost Vp v [x,y] vypocitana
    z merenych dat je VpZname = 1, jinak VpZname = 0. Pokud je VpZname = 0
    rychlost se tam bude interpolovat}
  SmoothVel: boolean; {if set to TRUE, velocities in the uppermost layer will
    be smoothed with number of smoothing passes = NrOfPass}
  NrOfPass: integer;
  MatA: T2DDoubleArray; {Matice A levych stran pro inverzi}
  VectX: TDoubleArray; {Vektor neznamych}
  VectStd: TDoubleArray; {Vektor standardnich odchylek}
  VectB: TDoubleArray; {Vektor pravych stran}
  OdpGf: TOdpGf; {odpaly shodne s geofony}
  NrOfKnownVel: integer; {pocet hodnot rychlosti vnucenych procesu}
  RegClen: double;
  MaxIt: integer; {maximalni pocet iteraci}
  Iterace: integer; {number of computed iterations}
  UseOctaveScript: Boolean;
  
  vel_prior: double;	{default value of velocities (a priori information)}
  vel_uncert: double;	{standard deviation of initial value of velocities}
  depth_prior: double;	{default (initial) value of depths (a priori information}
  depth_uncert: double;	{standard deviation of initial value of depths}
  data_uncert: double;	{standard deviation of travel time errors}
  min_vel: double;	{minimal velocity allowed in model}
  max_vel: double;		{maximal velocity allowed in model}
  vel_std: double;        {the standard deviation which will be assigned to a velocity
                        value out of range [min_vel; max_vel]. This velocity will
                        be deleted and the vel_prior value with vel_std will be
                        assigned instead}
  min_depth: double;	{minimal depth allowed in model}
  max_depth: double;	{maximal depth allowed in model}
  tol: double;		{the smallest singular value allowed in SVD}
  err: double;
  NumZero: double; {Cisla mensi nez NumZero se budou povazovat za nulu}
  MinTime: double; {the smallest arrival time which will be considered}
  WorkDir: string;
  WorkFile: string;


implementation


{$IFNDEF UNIX}
  {$IFDEF LINUX}
    {$DEFINE UNIX}
  {$ENDIF}
{$ENDIF}

{$DEFINE NO_PROFILE}


procedure TfrmMain.miExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.miOpenClick(Sender: TObject);
var
  fr: TextFile;
  a, b, c, d: Double;
  PocetRadku: integer;
  ErrString: string;
  Vrstvy: array of double;
  i, j: integer;
  TmpMin, TmpMax: double;
  TmpIdent: T2DDoubleArray;
  tmpStr, tmpStr1: string;
begin
  if OpenDialog1.Execute then
    begin
      AssignFile(fr, OpenDialog1.FileName);
      PocetOdpalu := 0;
      PocetRadku := 0;
      Screen.Cursor := CrHourGlass;
      try
        Reset(fr);
        repeat
          readln(fr, a, b, c, d);
          Inc(PocetRadku);
          if (PocetRadku = 1) AND (d <> 0) then
            begin
              ErrString := 'Error in file "' + OpenDialog1.FileName + '". Source coordinate line must be the first one in the file.';
              MessageDlg(ErrString, mtError, [mbAbort], 0);
              Exit;
            end;
          if d = 0 then
            Inc(PocetOdpalu);
        until EoF(fr);
        Reset(fr);

        PocetZaznamu := PocetRadku - PocetOdpalu;
        SetLength(ShotCoord, PocetOdpalu);
        SetLength(FieldTimeData, PocetZaznamu);
        SetLength(TimeDataOrig, PocetZaznamu);
        SetLength(GeophCoord, PocetZaznamu);

        PocetOdpalu := 0;
        PocetZaznamu := 0;
        repeat {cteme soubor prvnich nasazeni}
          readln(fr, a, b, c, d);
          if d <> 0 then {je to souradnice a cas na geofonu}
            begin
              Inc(PocetZaznamu);
              GeophCoord[PocetZaznamu - 1, 0] := a;
              GeophCoord[PocetZaznamu - 1, 1] := b;
              FieldTimeData[PocetZaznamu - 1, 0] := PocetOdpalu - 1;
              FieldTimeData[PocetZaznamu - 1, 1] := c;
              TimeDataOrig[PocetZaznamu - 1] := c;
              FieldTimeData[PocetZaznamu - 1, 2] := d;
            end
          else
            begin
              Inc(PocetOdpalu);
              ShotCoord[PocetOdpalu - 1, 0] := a;
              ShotCoord[PocetOdpalu - 1, 1] := b;
            end;
        until EoF(fr);
{Zjistime minimalni a maximalni x a y souradnice souboru a pocet vrstev}
        {min a max souradnice odpalu}
        SetLength(vrstvy, PocetOdpalu);
        for i := 0 to (pocetOdpalu - 1) do
          Vrstvy[i] := (ShotCoord[i,0]);
        MinX := RefrMinValue(Vrstvy);
        MaxX := RefrMaxValue(Vrstvy);

        for i := 0 to (pocetOdpalu - 1) do
          Vrstvy[i] := (ShotCoord[i,1]);
        MinY := RefrMinValue(Vrstvy);
        MaxY := RefrMaxValue(Vrstvy);

        {pocet vrstev}
        SetLength(Vrstvy, PocetZaznamu);
        for i := 0 to (PocetZaznamu - 1) do
          Vrstvy[i] := FieldTimedata[i,2];
        PocetVrstev := trunc(RefrMaxValue(Vrstvy));

        {min a max souradnice geofonu}
        for i := 0 to (PocetZaznamu - 1) do
          Vrstvy[i] := (GeophCoord[i,0]);
        TmpMax := RefrMaxValue(Vrstvy);
        TmpMin := RefrMinValue(Vrstvy);
        if TmpMax > MaxX then MaxX := TmpMax;
        if TmpMin < MinX then MinX := TmpMin;

        for i := 0 to (PocetZaznamu - 1) do
          Vrstvy[i] := (GeophCoord[i,1]);
        TmpMax := RefrMaxValue(Vrstvy);
        TmpMin := RefrMinValue(Vrstvy);
        if TmpMax > MaxY then MaxY := TmpMax;
        if TmpMin < MinY then MinY := TmpMin;
{konec zjistovani min a max souradnic}

{vytvorime identifikatory geofonu}
        SetLength(TmpIdent, PocetZaznamu, 2);
        VytvorIdentifikatory(GeophCoord, TmpIdent, PocetGf);
        for i := 0 to (PocetZaznamu - 1) do
          begin
            FieldTimeData[i, 3] := TmpIdent[i, 0];
            FieldTimeData[i, 4] := TmpIdent[i, 1];
          end;
        NajdiStejne(OdpGf, ShotCoord, GeophCoord, TmpIdent, FieldTimeData);
{konec vytvareni identifikatoru}

        frmMain.Caption := 'Refract3D - ' + OpenDialog1.FileName;
        btRunInversion.Enabled := True;
        miRun.Enabled := True;
        StatusBar1.SimpleText := 'File read successfully.';
{get the directory path}
        i := 0;
        tmpStr := OpenDialog1.FileName;
        while Pos(DirectorySeparator, tmpStr) > 0 do
          begin
            Delete(tmpStr, 1, 1);
            Inc(i);
          end;
        WorkDir := Copy(OpenDialog1.FileName, 1, i);
        i := 0;
        j := Length(tmpStr);
        tmpStr1 := tmpStr;
        while Pos('.', tmpStr) > 0 do
          begin
            Delete(tmpStr, 1, 1);
            Inc(i);
          end;
        if i = 0 then
          {the input file has no extension, assign to WorkFile the whole file name}
          WorkFile := Copy(tmpStr1, 1, Length(tmpStr))
        else
          {we do have an extension, use the file name without the extension}
          WorkFile := Copy(tmpStr1, 1, i - 1);
      finally
        CloseFile(fr);
        Screen.Cursor := CrDefault;
      end;
    end;
end;

procedure TfrmMain.miSaveClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
    ZapisVysledek(SaveDialog1.FileName);
end;

procedure TfrmMain.miAboutClick(Sender: TObject);
begin
  try
    Application.CreateForm(TfrmAbout, frmAbout);
    frmAbout.ShowModal;
  finally
    frmAbout.Free;
  end;
end;

procedure TfrmMain.frmInvCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  a : word;
begin
  a := MessageDlg('Really want to quit?', mtConfirmation, mbOKCancel, 0);
  if a = mrOK then
    begin
//      if ModelExists = TRUE then Smaz_vsechny_soubory();
      CanClose := TRUE;
    end;
  if a <> mrOK then
   CanClose := FALSE;
end;

procedure TfrmMain.btRunInversionClick(Sender: TObject);
var
  i, j, k, l: integer;
  XSize, YSize: integer;
  ZacatekGF, ZacatekCtver: integer;
  PocBun: integer;
  zmena: double;
  stara, nova, nova_std, diff: double;
  RMS: double;
  tmp: double;
  ResFileName: string;
  {$IFDEF UNIX}
  fw: TextFile;
  {$ENDIF}
begin
{transformace souradnic a casu pomoci Scale}
  Screen.Cursor := CrHourGlass;
  RegClen := RegClenMain;
  SetLength(ShotCoordTransp, PocetOdpalu);
  for i := 0 to (PocetOdpalu - 1) do
    begin
      ShotCoordTransp[i, 0] := ShotCoord[i, 0] / Scale;
      ShotCoordTransp[i, 1] := ShotCoord[i, 1] / Scale;
    end;
  SetLength(GeophCoordTransp, PocetZaznamu);
  for i := 0 to (PocetZaznamu - 1) do
    begin
      GeophCoordTransp[i, 0] := GeophCoord[i, 0] / Scale;
      GeophCoordTransp[i, 1] := GeophCoord[i, 1] / Scale;
    end;
  for i := 0 to (Length(FieldTimeData) - 1) do
    begin
      FieldTimeData[i, 1] := TimeDataOrig[i] / Scale;
    end;
  MinXT := MinX / Scale;
  MinYT := MinY / Scale;
  MaxXT := MaxX / Scale;
  MaxYT := MaxY / Scale;
{end of transformation}
  NrY := Round(MaxYT) - Trunc(MinYT) + 1;
  NrX := Round(MaxXT) - Trunc(MinXT) + 1;
//  if NrY > 1 then
//    NrX := Round(MaxXT) - Trunc(MinXT) + 1 {3D mereni}
//  else
//    NrX := PocetOdpalu + PocetGf; {profilove mereni}
  SetLength(Rychlosti, PocetVrstev, NrX, NrY);
  SetLength(RychlostiStd, PocetVrstev, NrX, NrY);
  SetLength(Mocnosti, PocetVrstev - 1, NrX, NrY);
  SetLength(MocnostiStd, PocetVrstev - 1, NrX, NrY);
  NrOfKnownVel := GetNrOfKnownVel();
{inicializace poli}
  for i := 0 to (PocetVrstev - 1) do
    for j := 0 to (NrX - 1) do
      for k := 0 to (NrY - 1) do
        Rychlosti[i, j, k] := -1;
  for i := 0 to (PocetVrstev - 2) do
    for j := 0 to (NrX - 1) do
      for k := 0 to (NrY - 1) do
        Mocnosti[i, j, k] := -1;
  SetLength(VpZname, NrX, NrY);
  for i := 0 to (NrX - 1) do
    for j := 0 to (NrY - 1) do
      VpZname[i, j] := 0;
{end of initialisation}
  SpoctiVp(FieldTimeData, Rychlosti, VpZname, ShotCoordTransp,
    GeophCoordTransp);

  if (NrY > 1) AND (NrX > 1) then
    InterpolujVp(Rychlosti, VpZname, 0, MaxDiff)  {3d measurements}
  else
    if NrY = 1 then
      InterpolujVpXProfil(Rychlosti, VpZname, 0, MaxDiff) {profile measurements
      in the direction of X}
    else
      InterpolujVpYProfil(Rychlosti, VpZname, 0, MaxDiff); {profile measurements
      in the direction of Y}

  Application.ProcessMessages;
     
  if SmoothVel = True then
    begin
      frmMain.StatusBar1.SimpleText := 'Smooothing direct wave...';
      Application.ProcessMessages;
      ZhladRychlosti(Rychlosti, 0, NrOfPass);
    end;

{  XSize := PocetOdpalu * PocetGf * (PocetVrstev - 1) +  NrX * NrY *
     (PocetVrstev - 1);}
{$IFDEF NO_PROFILE}
    XSize := PocetOdpalu * (PocetVrstev - 1) + PocetGf * (PocetVrstev - 1) +
      NrX * NrY * (PocetVrstev - 1); {3D measurement}
{$ELSE}
  if NrY > 1 then
    XSize := PocetOdpalu * (PocetVrstev - 1) + PocetGf * (PocetVrstev - 1) +
      NrX * NrY * (PocetVrstev - 1) {3D measurement}
  else
    XSize := PocetOdpalu * (PocetVrstev - 1) + PocetGf * (PocetVrstev - 1) +
      (pocetOdpalu + PocetGf) * (PocetVrstev - 1); {profile measurement}
{$ENDIF}
  YSize := PocetZaznamu;
  SetLength(VectX, XSize);
  SetLength(VectStd, XSize);
  SetLength(MatA, XSize, YSize + Length(OdpGf) + NrOfKnownVel);
  SetLength(VectB, YSize + Length(OdpGf) + NrOfKnownVel);
//  VyplnVectB(VectB, FieldTimeData);
  ZacatekGf :=  PocetOdpalu * (PocetVrstev - 1);
  ZacatekCtver := PocetOdpalu * (PocetVrstev - 1) + PocetGf * (PocetVrstev - 1);
  PocBun := NrX * NrY;
  for i := 0 to (XSize - 1) do
    for j := 0 to (YSize + Length(OdpGf) - 1) do
      MatA[i, j] := 0;
  Iterace := 0;
{$IFNDEF NO_PROFILE}
  if NrY = 1 then
    UrciProfilCoord(ShotCoord, GeophCoord, ProfilCoordTransp);
{$ENDIF}


  repeat
{$IFDEF NO_PROFILE}
    VyplnMatici(MatA, ShotCoordTransp, GeophCoordTransp, FieldTimeData,
        Rychlosti, PocetVrstev, PocetGf, NrX * NrY, OdpGf);
{$ELSE}
    if nrY > 1 then
      VyplnMatici(MatA, ShotCoordTransp, GeophCoordTransp, FieldTimeData,
        Rychlosti, PocetVrstev, PocetGf, NrX * NrY, OdpGf)
    else
      VyplnProfilovouMatici(MatA, ShotCoordTransp, GeophCoordTransp, FieldTimeData,
        Rychlosti, PocetVrstev, PocetGf, ProfilCoordTransp, OdpGf);
{$ENDIF}

    VyplnVectB(VectB, FieldTimeData, MatA);
{solving of system of equations}
    if UseOctaveScript = False then
      SpoctiSoustavu(MatA, VectB, XSize, YSize + Length(OdpGf) + NrOfKnownVel,
        ZacatekCtver, Length(FieldTimeData), VectX, VectStd, RMS)
    else
      begin
        ZapisMatA(Length(ShotCoordTransp), Length(FieldTimeData), PocetGf);
        ZapisVectB();
        {$IFDEF UNIX}
        SpustSVD();
        {$ENDIF}
        PrectiVectX(XSize);
        PrectiVectStd(XSize);
      end;
        
{processing the solution}
    zmena := 0;
    {assigning computed depths}
    for j := 0 to (PocetVrstev - 2) do
      for i := 0 to (PocetOdpalu - 1) do
        begin
          stara := Mocnosti[j, trunc(ShotCoordTransp[i, 0] - MinXT),
            trunc(ShotCoordTransp[i, 1] - MinYT)];
          nova := VectX[j * PocetOdpalu + i];
          if nova < 0 then nova := -1;
          if stara <> 0 then
            diff := abs(abs(stara) - abs(nova)) / abs(stara);
          if diff > zmena then zmena := diff;
          Mocnosti[j, trunc(ShotCoordTransp[i, 0] - MinXT),
            trunc(ShotCoordTransp[i, 1] - MinYT)] := nova;
          nova_std := VectStd[j * PocetOdpalu + i];
          MocnostiStd[j, trunc(ShotCoordTransp[i, 0] - MinXT),
            trunc(ShotCoordTransp[i, 1] - MinYT)] := nova_std;
        end;
    for j := 0 to (PocetVrstev - 2) do
      for i := 0 to (PocetGf - 1) do
        begin
          stara := Mocnosti[j, trunc(GeophCoordTransp[i, 0] - MinXT),
            trunc(GeophCoordTransp[i, 1] - MinYT)];
          nova := VectX[ZacatekGf + j * PocetGf + i];
          if nova < 0 then nova := -1;
          if stara <> 0 then
            diff := abs(abs(stara) - abs(nova)) / abs(stara);
          if diff > zmena then zmena := diff;
          Mocnosti[j, trunc(GeophCoordTransp[i, 0] - MinXT),
            trunc(GeophCoordTransp[i, 1] - MinYT)] := nova;
          nova_std := VectStd[ZacatekGf + j * PocetGf + i];
          MocnostiStd[j, trunc(GeophCoordTransp[i, 0] - MinXT),
            trunc(GeophCoordTransp[i, 1] - MinYT)] := nova_std;
        end;
  {assigning computed velocities}
  {$IFDEF NO_PROFILE}
        for j := 0 to (PocetVrstev - 2) do
          for i := 0 to (NrY - 1) do
            for k := 0 to (NrX - 1) do
              begin
                stara :=  Rychlosti[j + 1, k, i];
                tmp := VectX[ZacatekCtver + j * PocBun + i * NrX + k];
                {if the new velocity is within the [min_vel; max_vel] range then use it...}
                if (VectX[ZacatekCtver + j * PocBun + i * NrX + k] > 0) AND
                  ((1 / VectX[ZacatekCtver + j * PocBun + i * NrX + k] >= min_vel) AND
                  (1 / VectX[ZacatekCtver + j * PocBun + i * NrX + k] <= max_vel)) then
                      begin
                        nova := 1 / VectX[ZacatekCtver + j * PocBun + i * NrX + k];
                        if stara <> 0 then
                          diff := abs(abs(stara) - abs(nova)) / abs(stara);
                        if diff > zmena then zmena := diff;
                        nova_std := VectStd[ZacatekCtver + j * PocBun + i * NrX + k];
                      end
                else
                {...otherwise use the velocity estimate}
                  begin
                    nova := vel_prior;
                    nova_std := vel_std;
                  end;
                Rychlosti[j + 1, k, i] := nova;
                RychlostiStd[j + 1, k, i] := nova_std;
              end;
  {$ELSE}
    if NrY > 1 then
      begin
        for j := 0 to (PocetVrstev - 2) do
          for i := 0 to (NrY - 1) do
            for k := 0 to (NrX - 1) do
              begin
                stara :=  Rychlosti[j + 1, k, i];
                if (VectX[ZacatekCtver + j * PocBun + i * NrX + k] > 0) AND
                  ((1 / VectX[ZacatekCtver + j * PocBun + i * NrX + k] >= min_vel) AND
                  (1 / VectX[ZacatekCtver + j * PocBun + i * NrX + k] <= max_vel)) then
                    begin
                      nova := 1 / VectX[ZacatekCtver + j * PocBun + i * NrX + k];
                      if stara <> 0 then
                        diff := abs(abs(stara) - abs(nova)) / abs(stara);
                      if diff > zmena then zmena := diff;
                      nova_std := VectStd[ZacatekCtver + j * PocBun + i * NrX + k];
                    end
                else
                  begin
                    nova := vel_prior;
                    nova_std := vel_std;
                  end;
                Rychlosti[j + 1, k, i] := nova;
                RychlostiStd[j + 1, k, i] := nova_std;
              end;
      end {of if NrY > 1}
    else
      begin
        PocetUseku := Length(ProfilCoordTransp) - 2;
        for j := 0 to (PocetVrstev - 2) do
          for k := 0 to (Length(ProfilCoordTransp) - 2) do
            begin
              x := round((ProfilCoordTransp[k] + ProfilCoordTransp[k + 1])/2 - MinXT);
              stara := Rychlosti[j + 1, x, 0];
              if VectX[ZacatekCtver + j * PocetUseku + k] > 0 then
                nova := 1 / VectX[ZacatekCtver + j * PocetUseku + k]
              else
                nova := VelPrior;
              if stara <> 0 then
                diff := abs(abs(stara) - abs(nova)) / abs(stara);
              if diff > zmena then zmena := diff;
              for l := round(ProfilCoordTransp[k] - MinXT) to
                round(ProfilCoordTransp[k + 1] - MinXT) do
                Rychlosti[j + 1, l, 0] := nova;
            end;
      end;
  {$ENDIF}

//      InterpolujV0(Rychlosti, VpZname, 1, MaxDiff);
//      if SmoothVel = True then
//        ZhladRychlosti(Rychlosti, 1, NrOfPass);
  Inc(Iterace);
  if UseOctaveScript = True then
    RMS := ReadRMS('rms.csv');

  StatusBar1.SimpleText := 'Iteration ' + IntToStr(Iterace) +
    ', RMS: ' + FloatToStr(rms * Scale);

  {opening STDOUT}
  AssignFile(fw, '');
  Rewrite(fw);
  writeln(fw, 'Iteration ' + IntToStr(Iterace) + ', RMS: ' + FloatToStr(RMS * Scale));
  CloseFile(fw);

  RegClen := RegClen / ((iterace + 1));

  Application.ProcessMessages;

  ResFileName := WorkDir + WorkFile + '_it' + IntToStr(Iterace) + '.csv';
  ZapisVysledek(ResFileName);
  miSave.Enabled := True;
  until (Iterace >= MaxIt);
//  ZapisVysledek('vysledek.csv');

  if FileExists('VectXX.csv') then DeleteFile('VectXX.csv');
  Screen.Cursor := CrDefault;
end;

procedure TfrmMain.miConfigureClick(Sender: TObject);
var
  tmpStr: string;
begin
  try
    Application.CreateForm(TfrmConfigure, frmConfigure);
    {$IFDEF WINDOWS}
      frmConfigure.cbUseOctaveScript.Enabled := False;
    {$ENDIF}
    with frmConfigure do
      begin
        seNrOfPass.Value := NrOfPass;
        seNrOfIt.Value := MaxIt;
        seScale.Value := Scale;
        eRegClen.Text := FloatToStr(RegClenMain);
        seVelPrior.Value := vel_prior;
        seVelUncert.Value := vel_uncert;
        seMinVel.Value := min_vel;
        seMaxVel.Value := max_vel;
        seDepthPrior.Value := depth_prior;
        seDepthUncert.Value := depth_uncert;
        eTol.Text := FloatToStr(tol);
        eNumZero.Text := FloatToStr(NumZero);
        eMinTime.Text := FloatToStr(MinTime);
        if ShowModal = mrOK then
          begin
            NrOfPass := trunc(seNrOfPass.Value);
            MaxIt := trunc(seNrOfIt.Value);
            Scale := seScale.Value;
            vel_prior := seVelPrior.Value;
            vel_uncert := seVelUncert.Value;
            min_vel := seMinVel.Value;
            max_vel := seMaxVel.Value;
            depth_prior := seDepthPrior.Value;
            depth_uncert := seDepthUncert.Value;
            try
              tol := StrToFloat(eTol.Text);
            except
              on EConvertError do
                begin
                  tmpStr := 'Invalid floating point number in ''The smallest singular value allowed in SVD'' field found.';
                  MessageDlg(tmpStr, mtError, [mbAbort], 0);
                end;
              end;
            try
              NumZero := StrToFloat(eNumZero.Text);
            except
              on EConvertError do
                begin
                  tmpStr := 'Invalid floating point number in ''The smallest value allowed in SVD'' field found.';
                  MessageDlg(tmpStr, mtError, [mbAbort], 0);
                end;
              end;
            try
              minTime := StrToFloat(eMinTime.Text);
            except
              on EConvertError do
                begin
                  tmpStr := 'Invalid floating point number in ''The smallest arrival time'' field found.';
                  MessageDlg(tmpStr, mtError, [mbAbort], 0);
                end;
              end;

    //        RegClen := StrToFloat(frmConfigure.eRegClen.Text);
            if cbSmoothVel.Checked = True then
              SmoothVel := True
            else
              SmoothVel := False;
          end;
      end;
  finally
    frmConfigure.Free;
  end;
end;

procedure TfrmMain.frmMainCreate(Sender: TObject);
var
  i: integer;
begin
  DecimalSeparator := '.';
  SmoothVel := False;
  NrOfPass := 1;
  MaxIt := 6;
  RegClenMain := 0;
  Scale := 1;
  vel_prior := 2;	{default value of velocities (a priori information)}
  vel_uncert := 0.1;	{standard deviation of initial value of velocities}
  depth_prior := 2;	{default (initial) value of depths (a priori information}
  depth_uncert := 1;	{standard deviation of initial value of depths}
  data_uncert := 0.1;	{standard deviation of travel time errors}
  min_vel := 0.5;	{minimal velocity allowed in model}
  max_vel := 6;		{maximal velocity allowed in model}
  vel_std := 100;        {the standard deviation which will be assigned to a velocity
                        value out of range [min_vel; max_vel]. This velocity will
                        be deleted and the vel_prior value with vel_std will be
                        assigned instead}
  min_depth := 0.2;	{minimal depth allowed in model}
  max_depth := 5;	{maximal depth allowed in model}
  tol := 0.001;		{the smallest singular value allowed in SVD}
  err := 0.3;
  NumZero := 0.000000001; {Cisla mensi nez NumZero se budou povazovat za nulu}
  MinTime := 0.001; {the smallest arrival time which will be considered}

  {initialize sgKnownVel}
  with sgKnownVel do
    begin
      RowCount := 1000;
      ColCount := 5;
//      ScrollBars := ssAutoBoth;
    end;
  for i := 1 to (sgKnownVel.RowCount - 1) do
    SgKnownVel.Cells[0, i] := InttoStr(i);
  SgKnownVel.Cells[1,0] := 'x [m]';
  SgKnownVel.Cells[2,0] := 'y [m]';
  SgKnownVel.Cells[3,0] := 'v [km/s]';
  SgKnownVel.Cells[4,0] := 'layer';

  with sgKnownDepths do
    begin
      RowCount := 1000;
      ColCount := 5;
//      ScrollBars := ssAutoBoth;
      for i := 1 to (RowCount - 1) do
        Cells[0, i] := InttoStr(i);
      Cells[1,0] := 'x [m]';
      Cells[2,0] := 'y [m]';
      Cells[3,0] := 'depth [m]';
      Cells[4,0] := 'layer';
    end;
  UseOctaveScript := False;
end;

procedure TfrmMain.sgKnownVelDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
  jason: string;
  delka, i: integer;
  chr: Char;
  point_exist: Boolean;
  is_number: Boolean;
begin
  if Arow > 0 then
    begin
      i := 1;
      point_exist := False;
      is_number := True;
      jason := sgKnownVel.Cells[ACol, ARow];
      delka := Length(jason);
      while i <= delka do
        begin
          chr := jason[i];
          if chr = '.' then
            if point_exist = False then point_exist := True
            else is_number := False;
          if chr <> '.' then
            if IsNumeric(chr) = False then is_number := False;
          Inc(i);
        end;
      if is_number = False then
        begin
//          Delete(Jason, Length(Jason), 1);
          sgKnownVel.Cells[ACol, ARow] := '';
          MessageDlg('Error', 'Please, enter a numeric value.', mtError, [mbOK], 0);
//          Application.MessageBox('Please, enter a numeric value.', 'Error',
//               [smbOK], smsWarning, smbOK);
        end;
    end;

end;


initialization
  {$I main.lrs}

end.

